Index: django/templatetags/i18n.py
===================================================================
--- django/templatetags/i18n.py	(revision 7884)
+++ django/templatetags/i18n.py	(working copy)
@@ -1,8 +1,7 @@
 import re
 
-from django.template import Node, Variable, VariableNode
-from django.template import TemplateSyntaxError, TokenParser, Library
-from django.template import TOKEN_TEXT, TOKEN_VAR
+from django.template import Node, VariableNode, TokenParser, Variable, TemplateSyntaxError, Library
+from django.template.compiler import TOKEN_TEXT, TOKEN_VAR
 from django.utils import translation
 from django.utils.encoding import force_unicode
 
@@ -35,7 +34,7 @@
 
 class TranslateNode(Node):
     def __init__(self, value, noop):
-        self.value = Variable(value)
+        self.value = value
         self.noop = noop
 
     def render(self, context):
@@ -171,18 +170,13 @@
     the variable ``variable``. Make sure that the string
     in there is something that is in the .po file.
     """
-    class TranslateParser(TokenParser):
-        def top(self):
-            value = self.value()
-            if self.more():
-                if self.tag() == 'noop':
-                    noop = True
-                else:
-                    raise TemplateSyntaxError, "only option for 'trans' is 'noop'"
-            else:
-                noop = False
-            return (value, noop)
-    value, noop = TranslateParser(token.contents).top()
+    bits = parser.token_stream(token)
+    try:
+        value = bits.parse_expression()
+    except TokenSyntaxError:
+        bits.expected("expression")
+    noop = bits.pop_lexem('noop')
+    bits.assert_consumed()
     return TranslateNode(value, noop)
 
 def do_block_translate(parser, token):
Index: django/templatetags/cache.py
===================================================================
--- django/templatetags/cache.py	(revision 7884)
+++ django/templatetags/cache.py	(working copy)
@@ -1,5 +1,4 @@
-from django.template import Library, Node, TemplateSyntaxError, Variable, VariableDoesNotExist
-from django.template import resolve_variable
+from django.template import Library, Node, TemplateSyntaxError, VariableDoesNotExist, TokenSyntaxError
 from django.core.cache import cache
 from django.utils.encoding import force_unicode
 
@@ -8,7 +7,7 @@
 class CacheNode(Node):
     def __init__(self, nodelist, expire_time_var, fragment_name, vary_on):
         self.nodelist = nodelist
-        self.expire_time_var = Variable(expire_time_var)
+        self.expire_time_var = expire_time_var
         self.fragment_name = fragment_name
         self.vary_on = vary_on
 
@@ -22,7 +21,7 @@
         except (ValueError, TypeError):
             raise TemplateSyntaxError('"cache" tag got a non-integer timeout value: %r' % expire_time)
         # Build a unicode key for this fragment and all vary-on's.
-        cache_key = u':'.join([self.fragment_name] + [force_unicode(resolve_variable(var, context)) for var in self.vary_on])
+        cache_key = u':'.join([self.fragment_name] + [force_unicode(var.resolve_safe(context)) for var in self.vary_on])
         value = cache.get(cache_key)
         if value is None:
             value = self.nodelist.render(context)
@@ -50,11 +49,17 @@
 
     Each unique set of arguments will result in a unique cache entry.
     """
-    nodelist = parser.parse(('endcache',))
-    parser.delete_first_token()
-    tokens = token.contents.split()
-    if len(tokens) < 3:
-        raise TemplateSyntaxError(u"'%r' tag requires at least 2 arguments." % tokens[0])
-    return CacheNode(nodelist, tokens[1], tokens[2], tokens[3:])
+    nodelist = parser.parse_nodelist(('endcache',))
+    bits = parser.token_stream(token)
+    try:
+        expire_time = bits.parse_expression()
+    except TokenSyntaxError:
+        bits.expected("expression")
+    name = bits.pop_name()
+    if not name:
+        raise TemplateSyntaxError, "'cache' requires a fragment name"    
+    vary_on = bits.parse_expression_list()
+    bits.assert_consumed()    
+    return CacheNode(nodelist, expire_time, name, vary_on)
 
 register.tag('cache', do_cache)
